<?php

namespace HCM\FPA\Controllers;

use HCM\Util\Messages;
use Zeedhi\Framework\Controller\Crud;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO;
use Doctrine\ORM\EntityManager;
use Folha\Entities\FpaValorreferenciah;
use Folha\Entities\FpaValorreferenciam;
use Zeedhi\Framework\DTO\Response\Notification;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DataSource\DataSet;
use HCM\Util\HCMParameters;
use Zeedhi\Framework\DTO\Response\Error;
use HCM\FPA\Services\ValorReferenciaService;

class ValorReferenciaController extends Crud{
    
    protected $entityManager;
    protected $dataSourceName = 'fpa_valorreferenciam';
    protected $dataSourceName1 = 'fpa_valorreferenciah';
    protected $dataSourceName_get = 'fpa_valorreferencia_get';
    protected $parameterBagColumns = array('P_DTMESCOMPETENC', 'P_NRORG', 'P_NRORG_PADRAO');

    public function __construct (Manager $dataSourceManager, ParameterBag $parameterBag, HCMParameters $hcmParameters, $crudService, EntityManager $entityManager, ValorReferenciaService $valorReferenciaService){
        $this->parameterBag = $parameterBag;
        $this->hcmParameters = $hcmParameters;
        $this->crudService = $crudService;
        $this->entityManager = $entityManager;
        $this->valorRefernciaService = $valorReferenciaService; // objeto construído, porém ainda não usado;
        parent::__construct($dataSourceManager);
    }

    public function getValorReferencia(DTO\Request\Filter $request, DTO\Response $response) {
        $filterData = $request->getFilterCriteria();
        $filterData->setDataSourceName($this->dataSourceName_get);
        $newFilterData = $this->populateParameterBag($filterData);
        $dataSet = $this->dataSourceManager->findBy($newFilterData);
        $response->addDataSet($dataSet);
    }

    public function deleteValorReferencia(DTO\Request\DataSet $request, DTO\Response $response){
        try {
            $rows = $request->getDataSet()->getRows();
            $valorreferenciah = FpaValorreferenciah::findOneByNrvalorreferenciamAndNrvalorreferenciah($rows[0]['NRVALORREFERENCIAM'], $rows[0]['NRVALORREFERENCIAH']);
            $this->entityManager->remove($valorreferenciah);
            $this->entityManager->flush();
            $valorreferenciahh = FpaValorreferenciah::findByNrvalorreferenciam($rows[0]['NRVALORREFERENCIAM']);
            if(empty($valorreferenciahh)) {
                $valorreferenciam = FpaValorreferenciam::findOneByNrvalorreferenciamAndNrorg($rows[0]['NRVALORREFERENCIAM'], $rows[0]['NRORG']);
                $this->entityManager->remove($valorreferenciam);
                $this->entityManager->flush();
            }
            $response->addNotification(new Notification("row(s) deleted.", Notification::TYPE_SUCCESS));
        } catch (\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
    }

    protected function processConditionValue($condition) {
        return $condition['value'];
    }
    protected function populateParameterBag(FilterCriteria $filterCriteria) {

        $conditions = array();
        foreach ($filterCriteria->getConditions() as $condition) {
            $columnName = $condition['columnName'];
            if (in_array($columnName, $this->parameterBagColumns)) {
                $this->parameterBag->set($columnName, $this->processConditionValue($condition));
            } else {
                $conditions[] = $condition;
            }
        }
        $newFilterCriteria = new FilterCriteria(
            $filterCriteria->getDataSourceName(),
            $conditions,
            $filterCriteria->getPage(),
            $filterCriteria->getPageSize()
        );


        return $newFilterCriteria;
    }
} 