<?php

require_once 'base/FpaHoleritemagnetEntityBase.php';

/**
 * This class has been auto-generated by Setforms
 * 
 * @package Entity
 * 
 * @author  thalesvalias
 */
class FpaHoleritemagnetEntity extends FpaHoleritemagnetEntityBase
{


    /**
     * Retorna registros.
     *
     * @param TkDateTime $mesCompetencia  Mes de Competencia.
     * @param string     $nrOrg           Numero da Organizacao.
     * @param string     $cdBanco         Codigo do Banco.
     * @param string     $nrTipoMovimento Numero do Tipo de Movimento.
     *
     * @return array FpaHoleritemagnetEntity
     *
     * @author thalesvalias - 26/07/2012
     */
    public function retornaRegistros(TkDateTime $mesCompetencia, $nrOrg, $cdBanco, $nrTipoMovimento){
        return FpaHoleritemagnet::retornaRegistros($mesCompetencia, $nrOrg, $cdBanco, $nrTipoMovimento);
    }


    /**
     * Cria lista de objetos FpaHoleritemagnetEntity conforme array de tipo de registros.
     *
     * @param string $mesCompetencia  Mes de Competencia.
     * @param string $tipoRegistro    Tipo de Registro.
     * @param string $nrOrg           Numero da Organizacao.
     * @param string $cdBanco         Codigo do Banco.
     * @param string $nrTipoMovimento Numero do Tipo de Movimento.
     *
     * @return boolean
     *
     * @author thalesvalias - 02/08/2012
     */
    public function inicializaListaRegistros($mesCompetencia, $tipoRegistro, $nrOrg, $cdBanco, $nrTipoMovimento){
            $resultados = FpaHoleritemagnet::retornaRegistrosPorTipo($mesCompetencia, $tipoRegistro, $nrOrg, $cdBanco, $nrTipoMovimento);
        if (is_array($resultados) === true) {
            foreach ($resultados as $resultado) {
                $this->addItem($resultado, $resultado->getNrholeritemagnet());
            }

            return true;
        } else {
            return false;
        }
    }


    /**
     * Adiciona registro na lista.
     *
     * @param string  $nrOrg           Numero da Organizacao.
     * @param string  $mesCompetencia  Mes de competencia.
     * @param string  $tipoRegistro    Numero do tipo de registro.
     * @param string  $tipoInscricao   Numero do tipo de inscricao.
     * @param string  $nrInscricao     Numero da inscricao.
     * @param string  $linha           Linha do registro Holerite.
     * @param string  $cdBanco         Codigo do Banco.
     * @param string  $nrTipoMovimento Numero do Tipo de Movimento.
     * @param integer $sequencia       Numero sequencial representando um arquivo.
     *
     * @return void
     *
     * @author thalesvalias - 26/07/2012
     */
    public function insereRegistroLista(
        $nrOrg, $mesCompetencia, $cdBanco, $nrTipoMovimento, $idTpArquivo, $tipoRegistro, $nrInscricao, $linha, $nrSeqArquivo, $sequencia = null, $nrvinculom = null, $nrinscvinculo = null, $valor = null
    ){
        $item = new self();

        $item->setIdativo('S'); // Verificar.
        $item->setNrorg($nrOrg);
        $item->setMescompetencia($mesCompetencia);
        $item->setCdbanco($cdBanco);
        $item->setNrtipomoviment($nrTipoMovimento);
        $item->setIdtparquivo($idTpArquivo);
        $item->setIdtiporegistro($tipoRegistro);
        $item->setCdinscestrut($nrInscricao);
        $item->setDslinharegistro($linha);
        $item->setNrseqarquivo($nrSeqArquivo);
        $item->setNrseqregistro($sequencia);
        $item->setNrvinculom($nrvinculom);
        $item->setCdinscvinculo($nrinscvinculo);
        $item->setValor($valor);

        $this->addItem($item);

    }


    /**
     * Insere ou atualiza registro.
     *
     * @param string $nrOrg                Numero da organizacao.
     * @param string $mesCompetencia       Mes de competencia.
     * @param string $tipoRegistro         Tipo de registro Holerite.
     * @param string $nrInscricao          Numero de inscricao.
     * @param string $linha                Linha do registro.
     * @param string $nrVinculoM           Numero do vinculo.
     * @param string $cdBanco              Codigo do Banco.
     * @param string $nrTipoMovimento      Numero do Tipo de Movimento.
     * @param float  $valor                Valor do pagamento.
     * @param string $nrInscricaoVinculo   Numero de inscricao do Vinculo.
     *
     * @return void
     *
     * @author thalesvalias - 26/07/2012
     */
    public function persisteRegistro(
        $nrOrg, $mesCompetencia, $cdBanco, $nrTipoMovimento, $idTpArquivo, $tipoRegistro, $nrInscricao,
        $nrSeqArquivo, $nrSeqRegistro, $linha, $nrVinculoM, $nrInscricaoVinculo, $valor
    ){
        // Procura o registro na base.
        $item = FpaHoleritemagnet::retornaRegistro(
            $mesCompetencia, $nrOrg, $tipoRegistro, $nrInscricao, $nrVinculoM, $cdBanco, $nrTipoMovimento
        );

        if (is_object($item) === true) {
            $item->setNrholeritemagnet($item->getNrholeritemagnet());
            $item->setDslinharegistro($linha);
        } else {
            $item = new self();

            $item->setIdativo('S'); // Verificar.
            $item->setNrorg($nrOrg);
            $item->setMescompetencia($mesCompetencia);
            $item->setCdbanco($cdBanco);
            $item->setNrtipomoviment($nrTipoMovimento);
            $item->setIdtparquivo($idTpArquivo);
            $item->setIdtiporegistro($tipoRegistro);
            $item->setCdinscestrut($nrInscricao);
            $item->setNrseqarquivo($nrSeqArquivo);
            $item->setNrseqregistro($nrSeqRegistro);
            $item->setDslinharegistro($linha);
            $item->setNrvinculom($nrVinculoM);
            $item->setCdinscvinculo($nrInscricaoVinculo);
            $item->setValor($valor);
        }

        $item->persist();
    }


    /**
     * Procura registro na lista.
     *
     * @param string $nrInscricao     Numero da inscricao da empresa.
     * @param string $tpRegistro      Numero do tipo do registro.
     * @param string $cdBanco         Numero do tipo do registro.
     * @param string $nrTipoMovimento Numero do Tipo de Movimento.
     *
     * @return boolean
     *
     * @author thalesvalias - 27/06/2012
     */
    public function procuraRegistroLista($nrInscricao, $tpRegistro, $cdBanco, $nrTipoMovimento) {
        $itens = $this->getItems();
        foreach ($itens as $key => $item) {
            if (($item->getCdinscestrut() === (string)$nrInscricao)
                && ($item->getIdtiporegistro() === (string)$tpRegistro)
                && ($item->getCdbanco() === (string)$cdBanco)
                && ($item->getNrtipomoviment() === (string)$nrTipoMovimento)
            ) {
                return $key;
            }
        }

        return false;
    }


    /**
     * Remove todos os registros da Org. no mes de competencia.
     *
     * @param integer $nrOrg           Numero da Organizacao.
     * @param string  $mesCompetencia  Mes de competencia.
     * @param string  $cdBanco         Codigo do Banco.
     * @param string  $nrTipoMovimento Numero do Tipo de Movimento.
     *
     * @return void
     *
     * @author thalesvalias - 27/06/2012
     */
    public function retroceder($nrOrg, $mesCompetencia, $cdBanco, $nrTipoMovimento){

        $registros = $this->retornaRegistros($mesCompetencia, $nrOrg, $cdBanco, $nrTipoMovimento);
        if (count($registros) > 0) {
            foreach ($registros as $registro) {
                $this->addItem($registro);
                $this->removeItem($registro);
            }

            $this->persist();
        }
    }


    /**
     * Retorna o total de registros de acordo com o tipo de registro informado.
     *
     * @param string  $mesCompetencia Mes de Competencia.
     * @param integer $nrOrg          Numero da Organizacao.
     * @param string  $tiposRegistro  Tipos de Registros.
     * @param string  $cdBanco        Codigo do Banco.
     * @param string  $nrTipoMovimento Numero do Tipo de Movimento.
     *
     * @return number
     *
     * @author thalesvalias 07/08/2012
     */
    public function totalRegistrosPorTipos($mesCompetencia, $nrOrg, $tiposRegistro, $cdBanco, $nrTipoMovimento){
        $totalRegistros = FpaHoleritemagnet::totalRegistrosPorTipos($mesCompetencia, $nrOrg, $tiposRegistro, $cdBanco, $nrTipoMovimento);

        if (empty($totalRegistros) === false){
            $totalRegistros = end(end($totalRegistros));
        }

        return $totalRegistros;
    }


    /**
     * Retorna o ultimo(maior) numero sequencial do holerite de acordo com a competencia e o codigo do banco informados.
     *
     * @param string  $mesCompetencia Mes de Competencia.
     * @param integer $nrOrg          Numero da Organizacao.
     * @param string  $cdBanco        Codigo do Banco.
     * @param integer $nrestruturam   Numero da Estrutura.
     *
     * @return number
     *
     * @author felipesantos - 31/08/2015
     */
    public function retornaUltimoSequencialHolerite($mesCompetencia, $nrOrg, $cdBanco, $nrestruturam){
        $ultimoSequencial = FpaHoleritemagnet::retornaUltimoSequencialHolerite($mesCompetencia, $nrOrg, $cdBanco, $nrestruturam);

        if (empty($ultimoSequencial) === false){
            $ultimoSequencial = end(end($ultimoSequencial));
        }

        return $ultimoSequencial;
    }


    /**
     * Retorna o ultimo(maior) numero sequencial do registro 0 de acordo com a competencia e o codigo do banco informados.
     *
     * @param string  $mesCompetencia Mes de Competencia.
     * @param integer $nrOrg          Numero da Organizacao.
     * @param string  $cdBanco        Codigo do Banco.
     *
     * @return number
     *
     * @author thalesvalias 10/08/2012
     */
    public function retornaUltimoSequencialRegistro0($mesCompetencia, $nrOrg, $cdBanco){
        $ultimoSequencial = FpaHoleritemagnet::retornaUltimoSequencialRegistro0($mesCompetencia, $nrOrg, $cdBanco);

        if (empty($ultimoSequencial) === false){
            $ultimoSequencial = end(end($ultimoSequencial));
        }

        return $ultimoSequencial;
    }


    /**
     * Modifica a sequencia dos registros 0 que pertencem ao mesmo envio.
     * Mesmo envio = mesma competencia e mesmo banco. Cada 0 representa um novo arquivo.
     *
     * @param string  $mesCompetencia  Mes de Competencia.
     * @param integer $nrOrg           Numero da Organizacao.
     * @param string  $cdBanco         Codigo do Banco.
     *
     * @return void
     *
     * @author thalesvalias 10/08/2012
     */
    public function modificaSequenciaArquivoRemessa($mesCompetencia, $nrOrg, $cdBanco){

        $arquivosRemessa = FpaHoleritemagnet::retornaRegistros0Remessa($mesCompetencia, $nrOrg, $cdBanco);

        if (empty($arquivosRemessa) === false) {

            $contador = 1;
            foreach($arquivosRemessa as $arquivo) {

                $arquivo->setNrseqarquivo($contador);
                $arquivo->persist();

                $contador++;
            }
        }
    }
}