<?php

namespace HCM\FPA\ObrigacaoLegal\Rais;

use HCM\Util\Repositories;
use HCM\Util\DateUtil;

class RetrocedeRais {
    
    function __construct($hcmParameters,$entityManager)
    {
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
    }

    public function retrocede($nrorg, $dtmescompetenc)
    {
        $rais = Repositories::FPA_RAISMAGNET;

        try {
            $sql = <<<SQL
            SELECT r from $rais r
            WHERE r.nrorg = :nrorg AND r.mescompetencia = :dtmescompetenc

SQL;
            $params = array(
                "nrorg"=>$nrorg, 
                "dtmescompetenc"=>DateUtil::getDataDeString($dtmescompetenc)->format('d/m/Y'));

            $objs = $this->entityManager->createQuery($sql)->execute($params);
            foreach ($objs as $obj) {
                $obj->delete();
            }
            $this->entityManager->flush();
        } catch (\Exception $e) {
            throw $e;
        }
    }
}