<?php

namespace HCM\SST\Services;

use Doctrine\ORM\EntityManager;
use Folha\Entities\SstFichamedica;
use Folha\Entities\SstExamefichamed;
use Folha\Entities\SstItemexamefichamed;
use Folha\Entities\SstDoencafichamedica;
use HCM\Util\HCMParameters;
use HCM\Util\Messages;

class FichaMedicaService {
    
    protected $entityManager;
    protected $hcmParameters;
    
    public function __construct(EntityManager $entityManager, HCMParameters $hcmParameters) {
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
    }
    
    public function deleteFichaMedica($dataset) {
        
        $nrorg = $dataset["NRORG"];
        $nrfichamedica = $dataset["NRFICHAMEDICA"];
        $exames = SstExamefichamed::findByNrfichamedicaAndNrorg($nrfichamedica, $nrorg);
        $doenca = SstDoencafichamedica::findByNrfichamedicaAndNrorg($nrfichamedica, $nrorg);
        if (isset($exames[0])) {
            throw new \Exception(Messages::HCM05000_SST_FICHAMEDICA_EXISTS_EXAME_ERROR, 10);
        }
        if (isset($doenca[0])) {
            throw new \Exception(Messages::HCM05000_SST_FICHAMEDICA_EXISTS_DOENCA_ERROR, 10);
        }
        else {
            $this->entityManager->beginTransaction();
            $fichamedica = SstFichamedica::findOneByNrfichamedicaAndNrorg($nrfichamedica, $nrorg);
            $this->entityManager->remove($fichamedica);
            $this->entityManager->flush();
            $this->entityManager->commit();
        }
    }
    
    public function deleteExameFichaMed($dataset) {
        $nrorg = $dataset["NRORG"];
        $nrexamefichamed= $dataset["NREXAMEFICHAMED"];
        $itemexame = SstItemexamefichamed::findByNrexamefichamedAndNrorg($nrexamefichamed, $nrorg);
        if (isset($itemexame[0])) {
            throw new \Exception(Messages::HCM05000_SST_EXAMEFICHAMED_EXISTS_ITEMEXAME_ERROR, 10);
        }
        else {
            $this->entityManager->beginTransaction();
            $examefichamed = SstExamefichamed::findOneByNrexamefichamedAndNrorg($nrexamefichamed, $nrorg);
            $this->entityManager->remove($examefichamed);
            $this->entityManager->flush();
            $this->entityManager->commit();
        }
    }
}