<?php

namespace HCM\Util\PhpWord;

use PhpOffice\PhpWord\TemplateProcessor;
use PhpOffice\PhpWord\Settings;

class TemplateProcessorHCM extends TemplateProcessor {
    
    /**
     * @param string $macro
     *
     * @return string
     */
    protected static function ensureMacroCompleted($macro)
    {
        if (substr($macro, 0, 2) !== '[' && substr($macro, -1) !== ']') {
            $macro = '[' . $macro . ']';
        }

        return $macro;
    }
    
    
    /**
     * Retorna um array com todos os mnemônicos usados.
     * [mnemônicos] => null
     */
    public function getMnemonics()
    {
        preg_match_all('/\[\w+\]/', $this->tempDocumentMainPart, $matches);
        foreach($matches[0] as $val) {
            $out[$val] = null;
        }
        unset($matches);
        return $out;
    }
    
};

?>