<?php
namespace Contabilidade\Repositories;

use \Setforms2\Shared\Registry;

class Razao extends \Doctrine\ORM\EntityRepository
{
    public static function getContaInicialFinal(){
        $sql = "SELECT MIN(CDCONTCTBL) CDCONTINI, MAX(CDCONTCTBL) CDCONTFIN
                  FROM CONTCTBL
                 WHERE IDCONTCCUS <> 'R'
                 ORDER BY 1 ASC";

        try {
            return Registry::getEntityManager()->getConnection()->fetchAll($sql);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    public static function validaEvolucaoSaldo($empresa, $containicial, $contafinal, $datainicial){

        $sql = "SELECT TO_CHAR(MIN(DTLANCCONT), 'MM/YYYY') MESANO
                  FROM LANCCONT
                 WHERE cdempresa = :P_CDEMPRESA
                   AND NVL(IDLANCSALDO, 'N') = 'N'
                   AND CDCONTCTBL BETWEEN :P_CDCONTINI AND :P_CDCONTFIM
                   AND DTLANCCONT < :P_DTINICIAL";
        $paramsWhere = array(
            'P_CDEMPRESA'   => $empresa,
            'P_CDCONTINI'   => $containicial,
            'P_CDCONTFIM'   => $contafinal,
            'P_DTINICIAL'   => $datainicial
        );

        try {
            return Registry::getEntityManager()->getConnection()->fetchColumn($sql, $paramsWhere);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public static function selectRazao($nrorg)
    {
        try {
            $sql = "SELECT NRRAZAO
                                          FROM (SELECT NRRAZAO, ROWNUM LINHA
                                                  FROM (SELECT DISTINCT NRRAZAO
                                                          FROM RAZAO
                                                         WHERE NRORG = :P_NRORG
                                                         ORDER BY 1 DESC))
                                         WHERE LINHA = 11";

            $paramsWhere = array('P_NRORG'   => $nrorg);

            return Registry::getEntityManager()->getConnection()->fetchColumn($sql, $paramsWhere);
        }catch (\Exception $e)
        {
            throw $e;
        }
    }


    public static function deleteRazao($nrrazao)
    {
        try {
            $sql = "DELETE
                         FROM RAZAO
                        WHERE NRRAZAO <= '$nrrazao'";

            \Setforms2\Shared\Registry::getEntityManager()->getConnection()->exec($sql);
        }catch (\Exception $e)
        {
            throw $e;
        }
    }
}