/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_CLAUSULA                                                 */
/* Tabela : CLAUSULA                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 03/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_CLAUSULA'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_CLAUSULA
GO

CREATE TRIGGER DTULTATU_CLAUSULA
ON CLAUSULA
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'CLAUSULA', null, 'CDNORMA=' + CDNORMA +
                                       ';CDCLAUSULA='+ CDCLAUSULA+';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE CLAUSULA
      SET DTULTATUCLAU = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(CLAUSULA.CDCLAUSULA,0) = ISNULL(INSERTED.CDCLAUSULA,0)) AND
            (ISNULL(CLAUSULA.CDCLAUSULA,0) = ISNULL(INSERTED.CDCLAUSULA,0)) AND
            (ISNULL(CLAUSULA.CDNORMA,0)    = ISNULL(INSERTED.CDNORMA,0)) ;
   END;
END;
GO
